//importing required modules
import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';
//iris dataset
const csvUrl = 'https://gist.githubusercontent.com/BhavanaGIrni/a1b04f7e312137c2d9785215952f00f5/raw/955c00aead54c4c38a69403e2699de782789312a/iris.csv'
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};

const width = window.innerWidth;
const height = window.innerHeight - 100;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);
//main function
const main = async () => {
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
    .xValue((d) => d.petal_width)
    .yValue((d) => d.sepal_length)
    .margin({
      top: 20,
      right: 20,
      bottom: 40,
      left: 50,
    })
    .radius(5);

  svg.call(plot);
//setting dynamic axes
  const columns = [
    'petal_width',
    'sepal_width',
    'petal_length',
    'sepal_length',
  ];
  let i = 0;
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    svg.call(plot);
    i++;
  }, 10000);
};
main();